// ComNdrInspectorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ComNdrInspector.h"
#include "ComNdrInspectorDlg.h"
#include "WaitDialog.h"
#include "NDR.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MACRO_KEYWORD_INITTEXT		"   keyword here"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnSite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_SITE, OnSite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComNdrInspectorDlg dialog

CComNdrInspectorDlg::CComNdrInspectorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComNdrInspectorDlg::IDD, pParent), m_pvMemory( NULL )
{
	//{{AFX_DATA_INIT(CComNdrInspectorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hExitFromThread = ::CreateEvent( NULL, TRUE, FALSE, NULL );
	m_hThreadExited = ::CreateEvent( NULL, TRUE, FALSE, NULL );
}

CComNdrInspectorDlg:: ~ CComNdrInspectorDlg ()
{
	if ( m_pvMemory )
		::free( m_pvMemory );

	::CloseHandle( m_hExitFromThread );
	::CloseHandle( m_hThreadExited );
}

void CComNdrInspectorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComNdrInspectorDlg)
	DDX_Control(pDX, IDC_KEYWORD, m_wndKeyword);
	DDX_Control(pDX, IDC_INTERFACES, m_wndInterfaces);
	DDX_Control(pDX, IDC_CRITERIA, m_wndCriteria);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComNdrInspectorDlg, CDialog)
	//{{AFX_MSG_MAP(CComNdrInspectorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_SETFOCUS(IDC_KEYWORD, OnSetfocusKeyword)
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)
	ON_LBN_DBLCLK(IDC_INTERFACES, OnDblclkInterfaces)
	ON_BN_CLICKED(IDC_GETNDRDATA, OnGetndrdata)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComNdrInspectorDlg message handlers

BOOL CComNdrInspectorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//
	// Show wait dlg.
	//

	CWaitDialog			waitDialog( this, & m_pvMemory );
	if ( waitDialog.DoModal () == IDCANCEL )
	{
		::PostQuitMessage ( 0 );
	}
	
	//
	// Set the focus, init controls.
	//

	m_wndCriteria.SetCurSel( 0 );
	m_wndKeyword.SetWindowText( MACRO_KEYWORD_INITTEXT );
	m_wndInterfaces.SetFocus ();

	//
	// return.
	//
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CComNdrInspectorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CComNdrInspectorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CComNdrInspectorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAboutDlg::OnSite() 
{
	::ShellExecute( GetSafeHwnd (), "open", "http://www.vitoplantamura.com", NULL, NULL, SW_SHOW );
}

void CComNdrInspectorDlg::OnSetfocusKeyword() 
{
	CHAR		szText[ MAX_PATH ];

	m_wndKeyword.GetWindowText( szText, sizeof( szText ) );
	if ( ::strcmp( szText, MACRO_KEYWORD_INITTEXT ) == 0 )
		m_wndKeyword.SetWindowText( "" );

	return;
}

void CComNdrInspectorDlg::OnSearch() 
{
	// check for the init text string.

	CString		strInitTextCheck;
	m_wndKeyword.GetWindowText( strInitTextCheck );
	if ( strInitTextCheck == MACRO_KEYWORD_INITTEXT )
	{
		m_wndKeyword.SetFocus ();
		return;
	}

	// get the type of search.

	switch ( m_wndCriteria.GetCurSel () )
	{
	case 0: // keyword.
		{
			// get the text in the ctrl.

			CHAR		szName[ MAX_PATH ];
			m_wndKeyword.GetWindowText( szName, sizeof( szName ) );
			::_strlwr( szName );

			charstring	csName = szName;
			::TrimAtBothSides( csName );

			// iterate.

			int				s = m_wndInterfaces.GetCurSel ();
			if ( s == LB_ERR )
				s = 0;
			else
				++ s;

			CHAR			szBuffer[ MACRO_LISTBOXITEM_MAXLEN + 1 ];

			CONST CHAR*		pszText = csName.c_str();

			int			c = m_wndInterfaces.GetCount ();
			for ( int i=s; i<c; i ++ )
			{
				if ( m_wndInterfaces.GetText( i, szBuffer ) != LB_ERR )
				{
					::_strlwr( szBuffer );
					if ( ::strstr( szBuffer, pszText ) )
					{
						m_wndInterfaces.SetCurSel( i );
						break;
					}
				}
			}

			if ( i == c )
				::AfxMessageBox( "Sub-string not found !" );
		}
		break;

	case 1: // IID.
		{
			//
			// try opening the registry key and reading the interface name.
			//

			LONG		lRet, lRet2;

			HKEY		hInt = NULL;
			lRet = ::RegOpenKey( HKEY_CLASSES_ROOT, "Interface", & hInt );
			if ( lRet == ERROR_SUCCESS )
			{
				CHAR		szName[ MAX_PATH ];
				m_wndKeyword.GetWindowText( szName, sizeof( szName ) );
				charstring	csName = szName;
				::TrimAtBothSides( csName );

				GUID		guid;
				BOOL		bGuidRes = ::CharStrToGuid( szName, & guid );
				if ( bGuidRes && csName.size() >= 3 )
				{
					if ( csName[ 0 ] == '{' && csName[ csName.size() - 1 ] == '}' )
						csName = csName.substr( 1, csName.size() - 2 );

					HKEY		hSub1 = NULL, hSub2 = NULL;
					lRet = ::RegOpenKey( hInt, csName.c_str(), & hSub1 );
					lRet2 = ::RegOpenKey( hInt, ( "{" + csName + "}" ).c_str(), & hSub2 );

					if ( lRet == ERROR_SUCCESS || lRet2 == ERROR_SUCCESS )
					{
						// query value.

						DWORD		dwType = 0;

						CHAR		szBuffer[ 1 * 1024 ];
						DWORD		dwDataLen = sizeof( szBuffer );

						lRet = ::RegQueryValueEx(
							hSub1 ? hSub1 : hSub2,
							NULL, NULL, & dwType, (LPBYTE) szBuffer, & dwDataLen );

						if ( lRet == ERROR_SUCCESS && dwDataLen && dwType == REG_SZ )
						{
							int			pos = 0;
							while( TRUE )
							{
								pos = m_wndInterfaces.FindStringExact( pos, szBuffer );
								if ( pos != LB_ERR )
								{
									GUID*		pGuid = (GUID*) m_wndInterfaces.GetItemData( pos );
									if ( ::IsEqualGUID( *pGuid, guid ) )
									{
										m_wndInterfaces.SetCurSel( pos );
										break;
									}
								}
								else
								{
									::AfxMessageBox( "Unable to find interface in list box... !" );
									break;
								}
							}
						}
						else
						{
							::AfxMessageBox( "Unable to read the name of interface from registry !" );
						}

						// close key.

						if ( hSub1 )
							::RegCloseKey( hSub1 );
						if ( hSub2 )
							::RegCloseKey( hSub2 );
					}
					else
					{
						charstring			text = "Error when opening interface subkey ! ( name : \"" + csName + "\" )";
						::AfxMessageBox( text.c_str() );
					}
				}
				else
				{
					::AfxMessageBox( "Invalid IID entered !" );
				}

				::RegCloseKey( hInt );
			}
			else
			{
				::AfxMessageBox( "Unable to open \"Interface\" key in CLASSES_ROOT !" );
			}
		}
		break;
	}

	// return.

	return;
}

void CComNdrInspectorDlg::OnDblclkInterfaces() 
{
	// call the handler.

	OnGetndrdata ();
}

void CComNdrInspectorDlg::OnGetndrdata() 
{
	int			pos = m_wndInterfaces.GetCurSel ();
	if ( pos != LB_ERR )
	{
		GUID*		pGuid = (GUID*) m_wndInterfaces.GetItemData( pos );

		// show the report window.

		if ( m_wndReport.GetSafeHwnd () == NULL )
			m_wndReport.Create( CNDRReport::IDD, this );

		charstring		csReport;
		::GetReport( csReport, * pGuid );

		m_wndReport.SetReport( csReport.c_str() );
		m_wndReport.ShowWindow( SW_SHOW );
	}
}

BOOL CComNdrInspectorDlg::PreTranslateMessage(MSG* pMsg) 
{
	if ( pMsg->message == WM_KEYDOWN &&
		pMsg->wParam == VK_RETURN )
	{
		CWnd*		pwndFocus = CWnd::GetFocus();

		if ( pwndFocus == & m_wndKeyword ||
			pwndFocus == & m_wndCriteria )
		{
			OnSearch ();
			return TRUE;
		}
		else if ( pwndFocus == & m_wndInterfaces )
		{
			OnGetndrdata ();
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}
