// ComNdrInspectorDlg.h : header file
//

#if !defined(AFX_COMNDRINSPECTORDLG_H__273753D2_CEAD_49D5_8E37_0FC3F64A432F__INCLUDED_)
#define AFX_COMNDRINSPECTORDLG_H__273753D2_CEAD_49D5_8E37_0FC3F64A432F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////

#include "NDRReport.h"

/////////////////////////////////////////////////////////////////////////////

#define MACRO_LISTBOXITEM_MAXLEN							( 1 * 1024 )

/////////////////////////////////////////////////////////////////////////////
// CComNdrInspectorDlg dialog

class CComNdrInspectorDlg : public CDialog
{
// Construction
public:
	CComNdrInspectorDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~ CComNdrInspectorDlg ();

// Dialog Data
	//{{AFX_DATA(CComNdrInspectorDlg)
	enum { IDD = IDD_COMNDRINSPECTOR_DIALOG };
	CEdit	m_wndKeyword;
	CListBox	m_wndInterfaces;
	CComboBox	m_wndCriteria;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CComNdrInspectorDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Events
public:

	HANDLE		m_hExitFromThread;
	HANDLE		m_hThreadExited;

// Implementation
protected:
	HICON m_hIcon;

	PVOID		m_pvMemory;

	CNDRReport	m_wndReport;

	// Generated message map functions
	//{{AFX_MSG(CComNdrInspectorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetfocusKeyword();
	afx_msg void OnSearch();
	afx_msg void OnDblclkInterfaces();
	afx_msg void OnGetndrdata();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMNDRINSPECTORDLG_H__273753D2_CEAD_49D5_8E37_0FC3F64A432F__INCLUDED_)
