#if !defined(AFX_WAITDIALOG_H__2D0E0B11_F4BA_4D85_91B3_4E299F71378C__INCLUDED_)
#define AFX_WAITDIALOG_H__2D0E0B11_F4BA_4D85_91B3_4E299F71378C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WaitDialog.h : header file
//

#include "ComNdrInspectorDlg.h"

/////////////////////////////////////////////////////////////////////////////

#define MACRO_MSG_WAITCOMPLETE			( WM_USER + 0x100 )
#define MACRO_MSG_ADDSTRING				( WM_USER + 0x101 )

/////////////////////////////////////////////////////////////////////////////
// CWaitDialog dialog

class CWaitDialog : public CDialog
{
// Construction
public:
	CWaitDialog(CWnd* pParent = NULL, PVOID* ppvMemoryPtr = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CWaitDialog)
	enum { IDD = IDD_WAITDIALOG };
	CProgressCtrl	m_wndProgress;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWaitDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	typedef struct _ADDSTRING_REQUEST
	{
		_ADDSTRING_REQUEST ( CONST CHAR* pszString, CONST DWORD dwData ) :
			_dwData( dwData ), _pszString( NULL )
		{
			DWORD		dwLen = ::strlen( pszString );
			_pszString = (CHAR*) ::malloc( dwLen + 1 );
			if ( _pszString )
				::memcpy( _pszString, pszString, dwLen + 1 );
		}

		virtual ~ _ADDSTRING_REQUEST ()
		{
			if ( _pszString )
				::free( _pszString );
		}

		CHAR* _pszString;
		CONST DWORD _dwData;

	} ADDSTRING_REQUEST;

	static DWORD WINAPI WorkerThread( LPVOID lpParameter );

	DWORD			m_dwProgBarMax;

	CComNdrInspectorDlg*		m_pParent;
	PVOID*						m_ppvMemoryPtr;

	// Generated message map functions
	//{{AFX_MSG(CWaitDialog)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	//}}AFX_MSG
	afx_msg LRESULT OnWaitComplete( WPARAM wp, LPARAM lp );
	afx_msg LRESULT OnAddString( WPARAM wp, LPARAM lp );
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WAITDIALOG_H__2D0E0B11_F4BA_4D85_91B3_4E299F71378C__INCLUDED_)
